/*
 * SD_IDE64_GlobalVariables.h
 *
 * This file is going to hold oll the
 * global variables and defines of the project
 *
 */

#ifndef SD_IDE64_GLOBALVARIABLES_H
#define SD_IDE64_GLOBALVARIABLES_H

extern struct hddinfo* phddinfo;

typedef struct __sIDE64FILE
{
	struct chs			direntrychs;
	short int			direntryindex;
	struct direntry		direntry;
	unsigned long int	filesize;
	struct chs			lastblockchs;
	struct fileblock	*pseekbuffer;
	unsigned long int	seekpointer;
	short				flags;
} IDE64FILE;


#define CLEAR2MSBITSOF16	0x3fff
#define CLEAR2MSBITSOF8		0x3f
#define SET2MSBITSOF8		0xc0
#define SET1MSBITOF8		0x80
#define BIT6OF8				0x40

extern struct binaryflags
{
	int help;
	int	verbose;
	int	debug;
	int	error;
	int	readonly;
	int	cnvexts;
	int	preserve;
	int	recursive;
	int longdir;	//somewhat unfortunate name for this flag...
	int all;		//another unfortunate name for the long dir listing...
} flags;

// "C64-IDE V0.02-A "
static const char ide64signature[] =
{
	0x43, 0x36, 0x34, 0x2D, 0x49, 0x44, 0x45, 0x20, 0x56, 0x30, 0x2E, 0x30, 0x32, 0x2D, 0x41, 0x20
};

extern char *outputname, *devicename;	/* XXX (silverdr) Let's have this here for a while. */


/* The BLOCKSIZE define has to be replaced at some point by dynamic blocksize() */
#define BLOCKSIZE			512

/* The values for the very root sector of the disk */
#define ROOTCYL				0
#define ROOTHEAD			0
#define ROOTSEC				1
//extern struct rootblock rootblock, *prootblock;

/* Values for linked sectors chain */
#define FILE_LASTBLOCK		64

/* The values for the directory following */
#define NUMOFDIRENTRIES		15

/* The file attributes are defined here */
#define FILEATT_DEL			0
#define FILEATT_SEQ			1
#define FILEATT_PRG			2
#define FILEATT_USR			3
#define FILEATT_REL			4

#define FILEATT_DIR			16
#define FILEATT_LABEL		32

#define FILEATT_LOCKED		64
#define FILEATT_CLOSED		128

#define FILENAMELENGTH		16
#define FILEATT_ANY			19

#define TRAVERSE_DISPLAY	1
#define TRAVERSE_BACKUP		2
#define TRAVERSE_VALIDATE	4
#define TRAVERSE_RESTORE	8

/* BAM related defines and variables */
#define BLOCK_FREE			0
#define BLOCK_USED			1

#define BAM_READ			0
#define BAM_WRITE			1
#define BAM_FLUSH			2

#define BAMBITSPERBYTE		8L

#define HDDBLOCKS			0
#define CBMBLOCKS			1

#define EXT4COPY			0
#define EXT4DISPLAY			1

#endif
