/*
 * SD_IDE64_Protos.h
 *
 * This file is going to hold the prototypes of
 * the functions defined in other files
 *
 */
#ifndef SD_IDE64_PROTOS_H
#define SD_IDE64_PROTOS_H


/* command function prototypes */
int DoTest(int argc, char *argv[]);
int DoMkdir(int argc, char *argv[]);
int DoInfo(int argc, char *argv[]);
int DoMkfs(int argc, char *argv[]);
int DoRestore(int argc, char *argv[]);
int DoFsck(int argc, char *argv[]);
int DoMv(int argc, char *argv[]);
/* EXPERIMENTAL */
int DoLs(int argc, char *argv[]);
int DoBackup(int argc, char *argv[]);
int DoRm(int argc, char *argv[]);
int DoRmDir(int argc, char *argv[]);
int DoRead(int argc, char *argv[]);
int DoWrite(int argc, char *argv[]);
/* OBSOLETE */
//int DoRmnode(int argc, char *argv[]);
//int DoLsOld(int argc, char *argv[]);


int SD_IDE64_BlockRead(FILE *, struct chs *, unsigned char *);
int SD_IDE64_BlockWrite(FILE *, struct chs *, unsigned char *);
int SD_IDE64_ReadFileBlock(struct chs *, struct fileblock *);

int SD_IDE64_DriveLogin(const char *);
int SD_IDE64_DriveLogout(void);
void SD_IDE64_PrintDriveInfo(struct hddinfo *);

int SD_IDE64_CDPath(char *);
int SD_IDE64_DirectoryAllocEntry(struct chs *);
int SD_IDE64_DisplayDirEntry(struct direntry *);
int SD_IDE64_DirectoryFindEntries(struct ide64node *);
int SD_IDE64_DirectoryFindIn(char *, unsigned char, struct chs *);
int SD_IDE64_DirectoryMk(unsigned char *);
void SD_IDE64_DirectoryCD2Root(void);
int SD_IDE64_FSRTraverse(struct chs *, struct chs *, int);
int SD_IDE64_FSNewRTraverse(char *, struct chs *, int);
int SD_IDE64_DirectoryScan(struct chs *, int);
/* OBSOLETE */
// int SD_IDE64_CD(char *);
// int SD_IDE64_FSTraverse(struct chs *, int);

long int SD_IDE64_LocalRTraverse(char *, int);
long int SD_IDE64_Bytes2CBMBlocks(long int);
long int SD_IDE64_Bytes2HDDBlocks(long int);
unsigned char SD_IDE64_Extension2FileAttByte(char *);
char * SD_IDE64_FileAttByte2Extension(unsigned char, char *, int);

long int SD_IDE64_CHS2LogicalBlock(struct chs *pchs);
struct chs * SD_IDE64_LogicalBlock2CHS(int, struct chs *);
int SD_IDE64_ValidCHS(struct chs *);
unsigned char * SD_IDE64_CBMFilename2Filename(unsigned char *, unsigned char *, unsigned char);
unsigned char * SD_IDE64_Filename2CBMFilename(unsigned char *, unsigned char *);
char * SD_IDE64_Filename(const char *);
int SD_IDE64_Filename2FileAttByte(char *);
/* OBSOLETE */
//unsigned char * SD_IDE64_Filename2CBMFilename(unsigned char *, unsigned char *, unsigned char *);

int SD_IDE64_GetBAMBit(struct chs *);
int SD_IDE64_SetBAMBit(struct chs *, int);
int SD_IDE64_BAMByte(unsigned long int, int, unsigned char);
long int SD_IDE64_FindFreeBlock(void);
long int SD_IDE64_FindFreeBlocks(int);
long int SD_IDE64_BlocksFree();

int SD_IDE64_FileRead(FILE *, struct ide64node *);
int SD_IDE64_FileWrite(IDE64FILE *, FILE *);
IDE64FILE * SD_IDE64_FileOpen(unsigned char *, unsigned char, const char *);
int SD_IDE64_FileCreate(unsigned char *, unsigned char);
int SD_IDE64_FileClose(IDE64FILE *);
int SD_IDE64_FileExtend(IDE64FILE *);
int SD_IDE64_FileCopy(struct direntry *);
int SD_IDE64_FileValidate(struct direntry *);
int SD_IDE64_FileFreeBlocks(struct chs *);
int SD_IDE64_NodeDelete(struct ide64node *);
/* OBSOLETE */
//int SD_IDE64_FileRead(FILE *, struct chs *);
//int SD_IDE64_FileDelete(char *);

const char *bb_mode_string(int);


/* macros */
#define PATH	0
#define FILENAME	1
#define pathOnly(ppath)	disassemblePath((ppath), (PATH))
#define filenameOnly(ppath)	disassemblePath((ppath), (FILENAME))


extern unsigned char frompetascii[256];
extern unsigned char topetascii[256];

/*
 * SD_IDE64_ASCII2PETASCII()
 *
 * This function converts the ASCII character into its PETASCII equivalent.
 * RETURNS: PETASCII representation of the given char
 */
#define SD_IDE64_ASCII2PETASCII(character) topetascii[character]

/*
 * SD_IDE64_PETASCII2ASCII()
 *
 * This function converts the PETASCII character into its ASCII equivalent.
 * RETURNS: ASCII equivalent of the given PETASCII char
 */
#define SD_IDE64_PETASCII2ASCII(character) frompetascii[character]


#endif
