#!/bin/sh

#
# TODO:
# - check for errors ($?)
# - rumour has it that it possible to have such config per-user
#

echo
echo "This script will try to install .d64 virtual filesystem support"
echo "in your Midnight Commander setup."
echo "You need to have priviliges to do so. Every file will be backed up"
echo "but watch your ass anyway... You have been warned."
echo
echo "Please enter correct path for system-wide MC directory:"

read -p "[press RETURN for default: /usr/share/mc :" MCBASE

if test x"$MCBASE" = x; then
    MCBASE="/usr/share/mc"
fi

echo "Using $MCBASE"
echo "Installing script..."
install -m 755 ide64 "$MCBASE/extfs"

echo "Updating $MCBASE/extfs/extfs.ini file..."

IS=`grep ^ide64 "$MCBASE/extfs/extfs.ini"`

if test x"$IS" = x; then
    cp "$MCBASE/extfs/extfs.ini" "$MCBASE/extfs/extfs.ini.old"
    echo ide64 >> "$MCBASE/extfs/extfs.ini"
else
    echo "It seems that ide64 already is there, skipping"
fi

IS=`grep ^ide64 "$MCBASE/extfs/extfs.ini"`

if test x"$IS" = x; then
    echo "Operation failed, it seems that you have no rights to write that file."
    echo "Terminating."
    exit 1
fi

echo "Updating $MCBASE/mc.ext file..."

IS=`grep IDE64 "$MCBASE/mc.ext"`

if test x"$IS" = x; then
    cp "$MCBASE/mc.ext" "$MCBASE/mc.ext.old"
    cat "$MCBASE/mc.ext.old" | awk '
	/^default\/\*/ {
	print "# IDE64 hard disk image file";
	print "regex/\.(hdd|HDD|ide|IDE|ide64|IDE64)$";
	print "	Open=%cd %p#ide64";
	print "	View=%view{ascii} sd_ide64 -n -d %p info; echo; sd_ide64 -R -n -d %p ls -a";
	printf "\n";
	print "type/^IDE64";
	print "	Open=%cd %p#ide64";
	print "	View=%view{ascii} sd_ide64 -n -d %p info; echo; sd_ide64 -R -n -d %p ls -a";
	printf "\n"; }
	{ print $0 } ' > "$MCBASE/mc.ext"
else
    echo "It seems that IDE64 already is there, skipping"
fi

IS=`grep IDE64 "$MCBASE/mc.ext"`

if test x"$IS" = x; then
    echo "Operation failed, it seems that you have no rights to write that file."
    echo "Terminating."
    exit 1
fi

echo "Done. Restart all Midnight Commander instances."
echo "Good day."
